<?php
/*****************************************************************************
FozzyMail : Web based mail client created by Matthieu Fron
Copyright (C) 2003  Matthieu Fron

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

web site : http://fozzymail.mferon.com
web contact : fozzymail@mferon.com
******************************************************************************/
include("fozzyseens.php");
function get_attach_infos($ud)
{
	$result = 0;
	$cnt = 0;
	$fd = @dir($ud);
	while($file = $fd->read())
	{
	    if(($file != ".") && ($file != "..") && ( $file != "inbox.php" ) && ( $file != "contacts.php" ) && ( $file != "seens.php" )
	    	 && ($file != "..") && ( $file != "diff" ) && ( $file != "arch" ) && ( $file != "sent" ) && ( $file != "tmp" ) && ( $file != "supp" ))
		{
			$cnt++;
			$result += filesize("$ud$file");
		}
	}
	$fd->close();
	if ( $cnt > 0 )
	{
		$result = get_readable_size($result);
	}
	return(Array("size"=>$result,"count"=>$cnt));
}
function get_readable_size($result)
{
	if ( $result < 1024 )
		$result = $result . " o";
	else if ( $result < 1304576 )
		$result = sprintf("%01.2f Ko",(ceil(($result/1024)*100)/100));
	else
		$result = sprintf("%01.2f Mo",(ceil(($result/1304576)*100)/100));
	return($result);
}
function ends($chk)
{
	if ( $chk > 1 ) return "s";
}
function getmicrotime()
{    
	list($usec, $sec) = explode(" ",microtime());    
	return ((float)$usec + (float)$sec);  
}
$perfs=Array();
function recu($val)
{
	ereg("([0-9]{1,2} [a-zA-Z]* 20[0-9][0-9] [0-2][0-9]:[0-5][0-9]:[0-5][0-9])",$val,$regs);
	return($regs[1]);
}
function tri_expe_desc($a,$b)
{
	return ((-1) * strcasecmp($a->hd["from"],$b->hd["from"]));
}
function tri_expe_asc($a,$b)
{
	return strcasecmp($a->hd["from"],$b->hd["from"]);
}
function tri_subj_desc($a,$b)
{
	return ((-1) * strcasecmp($a->hd["subject"],$b->hd["subject"]));
}
function tri_subj_asc($a,$b)
{
	return strcasecmp($a->hd["subject"],$b->hd["subject"]);
}
function tri_size_desc($a,$b)
{
	if ( (1*$a->size) > (1*$b->size) ) 
		return -1;
	else if ( (1*$a->size) < (1*$b->size) ) 
		return 1;
	return 0;
}
function tri_size_asc($a,$b)
{
	if ( (1*$a->size) > (1*$b->size) ) 
		return 1;
	else if ( (1*$a->size) < (1*$b->size) ) 
		return -1;
	return 0;
}
function tri_date_desc($a,$b)
{
	$ati = strtotime(recu($a->hd["received"]));
	$bti = strtotime(recu($b->hd["received"]));
	if ( $ati > $bti ) 
		return -1;
	else if ( $ati < $bti ) 
		return 1;
	return 0;
}
function tri_date_asc($a,$b)
{
	$ati = strtotime(recu($a->hd["received"]));
	$bti = strtotime(recu($b->hd["received"]));
	if ( $ati > $bti ) 
		return 1;
	else if ( $ati < $bti ) 
		return -1;
	return 0;
}
function fozzy_mime_decode($flux)
{
	$retmp = imap_mime_header_decode($flux);
	$retour='';
	foreach( $retmp as $ret )
	{
		$retour .= $ret->text;
	}
	return($retour);
}
class FozzyMail_mail
{
	var $id;
	var $size;
	var $attach;
	var $seen;
	var $hd;
	var $text;
	var $html;
	var $attanb;
	var $atta;
	var $textEncoding;
	var $textCharset;
	var $htmlEncoding;
	var $htmlCharset;
	var $messnb;
	var $boxid;
	var $messid;
	var $typeid;
	var $ud;
	var $tmp;
	
	function FozzyMail_mail($pop_str, $udir)
	{
		$this->ud = $udir;
		$tmp = split(" ",$pop_str);
		$this->id = $tmp[0];
		$this->size = $tmp[1];
		$this->attach=false;
		$this->seen=false;
		$this->hd=Array();
		$this->text="";
		$this->html="";
		$this->attanb=0;
		$this->files=Array();
		$this->messnb=0;
		$this->boxid=-1;
		$this->messid="";
		$this->typeid=0;
		$this->tmp=0;
	}
	function load_descrmess($fs)
	{
		$ret=false;
		{
			fputs($fs,"TOP ".$this->id." 1\r\n");
			if (substr(($rep = fgets($fs)),0,3) == "+OK" )
			{
				if ( ($ret = $this->load_header($fs,$this->hd)) != false )
				{
					if ( eregi("multipart/mixed",$this->hd["content-type"])) $this->attach = true;
					while( fgets($fs) != ".\r\n" )
					{
					}
				}
			}
		}
		return($ret);
	}
	function load_header($fs,&$hd)
	{
		$secur=0;
		while( (($rep = fgets($fs) ) != "\r\n" ) && ( $secur != 1000 ))
		{
			$secur++;
			if ( $rep === false ) break;
			if ( ereg("^[A-Z]{1}",$rep ) )
			{
				ereg("(^[-a-zA-Z]+):",$rep,$regs);
				$lastfield = strtolower($regs[1]);
				$hd[$lastfield] .= ereg_replace("(^[-a-zA-Z]+): ","",$rep);
			}
			else
			{
				$hd[$lastfield] .= $rep;
			}
		}
		if ( $hd["content-type"] == "" ) $hd["content-type"] = "text/plain";
		if ( $rep === false )
			return(false);
		else
			return(true);
	}
	function load_fullmess($fs)
	{
		$ret=false;
		fputs($fs,"RETR ".$this->id." \r\n");
		if (substr(($rep = fgets($fs)),0,3) == "+OK" )
		{
			if ( ($ret = $this->load_message($fs)) != false )
			{
				if ( $this->attanb > 0 ) $this->attach=true;
			}
		}
		return($ret);
	}
	function load_message($fs)
	{
		$this->load_header($fs,$this->hd);
		eregi("(^[a-z]+)",$this->hd["content-type"],$regs);
		if ( strtolower($regs[1]) == "multipart" )
		{
			if ( !eregi("boundary[ \r\n\t]*=[ \r\n\t]*\"([^\"]*)\"",$this->hd["content-type"],$rgs) )
				eregi("boundary[ \r\n\t]*=[ \r\n\t]*([^\r\n\t ]*)",$this->hd["content-type"],$rgs);
			$this->load_multiparts($fs,$rgs[1],0);
		}
		else if ( strtolower($regs[1]) == "text")
		{
			$rep = $this->load_text($fs,$this->hd);
		}
		else if ( strtolower($regs[1]) == "image")
		{
			$rep = $this->load_binary($fs,$this->hd);
		}
		return($rep);
	}
	function load_multiparts($fs,$bound,$next)
	{
		$end = "--" . $bound . "--\r\n";
		$skip=true;
		$ret="";
		do
		{
			$hd="";
			if ( $next == 0 )
			{
				while ( !ereg("--".quotemeta($bound),$ret) )
				{
					$ret  = fgets($fs);
					if ( $ret == ".\r\n" ) return;
				}
			}
			if ( $ret != $end )
			{
				$this->load_header($fs,$hd);
			
				eregi("(^[a-z]+)",$hd["content-type"],$regs);
				if ( strtolower($regs[1]) == "multipart" )
				{
					eregi("boundary[ \r\n\t]*=[ \r\n\t]*\"([^\"]*)\"",$hd["content-type"],$rgs);
					$ret=$this->load_multiparts($fs,$rgs[1],0);
				}
				else if (( strtolower($regs[1]) == "text") && ( !ereg("^attachment[; \r\n\t]*",$hd["content-disposition"] ) ))
				{
					if ( ($ret=$this->load_delimited_text($fs,$hd,quotemeta($bound))) == "--".$bound."\r\n" )
					{
						$ret = $this->load_multiparts($fs,$bound,1);
					}
				}
				else
				{
					$ret = $this->load_delimited_binary($fs,$hd,quotemeta($bound));
				}
			}
		}
		while( $ret != $end );
		return( $ret );
	}
	function load_delimited_binary($fs,$hd,$bound)
	{
		$dec = 0;
		eregi("(^[a-z]+)\/([a-z]+)",$hd["content-type"],$regs);
		$type = $regs[1];
		$mime = $regs[2];
		$secu="";
		if ( $type == "message" )
		{
			$filename=stripslashes($bound."_EML_".($this->messnb++).".eml");
			$attach=true;
			$this->attanb++;
		}
		else
		{
			$reg = eregi("name[\s]*=\"?([^\"\r\n\t]*)",$hd["content-type"],$filet);
			$filename=$filet[1];
			$filename=fozzy_mime_decode(urldecode($filename));
			eregi("\.([a-z0-9]*)$",strtolower($filename),$parts);
			if (( $parts[1] == "php" ) ||
				( $parts[1] == "php3" ) ||
				( $parts[1] == "vbs" ) ||
				( $parts[1] == "java" ) ||
				( $parts[1] == "asp" ) ||
				( $parts[1] == "pif" ) ||
				( $parts[1] == "bat" ) ||
				( $parts[1] == "pl" ) ||
				( $parts[1] == "scr" ) ||
				( $parts[1] == "jsp" ) )
				$secu = ".txt";
		}
		if ( $filename == "" )
		{
			if ( $hd["content-id"] != "" )
			{
				$filename = base64_encode($hd["content-id"]);
			}
		}
		$fp=fopen($this->ud.$filename.$secu,"w");
		if ( eregi("base64",$hd["content-transfer-encoding"] ) )
			$dec = 1;
		else if ( eregi("quoted-printable",$hd["content-transfer-encoding"] ) )
			$dec = 2;
//			echo $dec."==1";
		while(( ($rep=fgets($fs)) != ".\r\n" ) && ( !feof($fs) ))
		{
/*			echo "\r\n**************\r\n";
			echo $rep;
			echo base64_decode($rep);
			echo "\r\n**************\r\n";*/
			if ( ereg($bound,$rep) ) break;
			$fsize += strlen($rep);
			if ( $dec == 1 )
				fwrite($fp,base64_decode($rep));
			else if ( $dec == 2 )
				fwrite($fp,quoted_printable_decode($rep));
			else
				fwrite($fp,$rep);
		}
		fclose($fp);
		if ( ereg("^attachment[; \r\n\t]*",$hd["content-disposition"] ) || ereg("^inline[; \r\n\t]*",$hd["content-disposition"] ) )
		{
			$this->attanb++;
			$attach=true;
		}
		$this->files[]=Array( 	"Type" => $type,
								"Name"=>$filename,
								"EnrName"=>$filename.$secu,
								"Size"=>$fsize,
								"ContId"=>ereg_replace("[<>\r\n]","",$hd["content-id"]),
								"attach"=>$attach);
		return($rep);
	}
	function load_delimited_text($fs,$hd,$bound)
	{
		$ret="";
		$rep="";
		while(( ($rep=fgets($fs)) != ".\r\n" ) && ( !feof($fs) ))
		{
			if ( ereg($bound,$rep) )
			{
				if ( eregi("quoted-printable",$hd["content-transfer-encoding"] ) ) $ret = quoted_printable_decode($ret);
				else if ( eregi("base64",$hd["content-transfer-encoding"] ) ) $ret = base64_decode($ret);
				if ( eregi("text/plain",$hd["content-type"]) )
				{
					if ( !is_array($this->text) )
					{
						$this->text = $hd;
						$this->text["texte"] = $ret;
					}
				}
				else
				{
					$this->html = $hd;
					$this->html["texte"] = $ret;
				}
				break;
			}
			else
			{
				$ret .= $rep;
			}
		}
		return($rep);
	}
	function load_binary($fs,$hd)
	{
		$dec = 0;
		eregi("(^[a-z]+)\/([a-z]+)",$hd["content-type"],$regs);
		$type = $regs[1];
		$mime = $regs[2];
		$secu="";
		if ( $type == "message" )
		{
			$filename=stripslashes($bound."_EML_".($this->messnb++).".eml");
			$attach=true;
			$this->attanb++;
		}
		else
		{
			$reg = eregi("name[\s]*=\"?([^\"\r\n\t]*)",$hd["content-type"],$filet);
			$filename=$filet[1];
			$filename=fozzy_mime_decode(urldecode($filename));
			eregi("\.([a-z0-9]*)$",strtolower($filename),$parts);
			if (( $parts[1] == "php" ) ||
				( $parts[1] == "php3" ) ||
				( $parts[1] == "vbs" ) ||
				( $parts[1] == "java" ) ||
				( $parts[1] == "asp" ) ||
				( $parts[1] == "pif" ) ||
				( $parts[1] == "bat" ) ||
				( $parts[1] == "pl" ) ||
				( $parts[1] == "scr" ) ||
				( $parts[1] == "jsp" ) )
				$secu = ".txt";
		}
		if ( $filename == "" )
		{
			if ( $hd["content-id"] != "" )
			{
				$filename = base64_encode($hd["content-id"]);
			}
		}
		$fp=fopen($this->ud.$filename.$secu,"w");
		if ( eregi("base64",$hd["content-transfer-encoding"] ) )
			$dec = 1;
		else if ( eregi("quoted-printable",$hd["content-transfer-encoding"] ) )
			$dec = 2;
		while( !feof($fs) && ($rep=fgets($fs,1024)) != ".\r\n" )
		{
			$fsize += strlen($rep);
			if ( $dec == 1 )
				fwrite($fp,base64_decode($rep));
			else if ( $dec == 2 )
				fwrite($fp,quoted_printable_decode($rep));
			else
				fwrite($fp,$rep);
		}
		fclose($fp);
		if ( ereg("^attachment[; \r\n\t]*",$hd["content-disposition"] ) || ereg("^inline[; \r\n\t]*",$hd["content-disposition"] ) )
		{
			$this->attanb++;
			$attach=true;
		}
		$this->files[]=Array( 	"Type" => $type,
								"Name"=>$filename,
								"EnrName"=>$filename.$secu,
								"Size"=>$fsize,
								"ContId"=>ereg_replace("[<>\r\n]","",$hd["content-id"]),
								"attach"=>$attach);
		return($rep);
	}
	function load_text($fs,$hd)
	{
		$ret="";
		$rep="";
		while( (($rep=fgets($fs)) != ".\r\n" ) && ( !feof($fs) ))
		{
			$ret .= $rep;
		}
		if ( eregi("quoted-printable",$hd["content-transfer-encoding"] ) ) $ret = quoted_printable_decode($ret);
		else if ( eregi("base64",$hd["content-transfer-encoding"] ) ) $ret = base64_decode($ret);
		if ( eregi("text/plain",$hd["content-type"]) )
		{
			$this->text = $hd;
			$this->text["texte"] = $ret;
		}
		else
		{
			$this->html = $hd;
			$this->html["texte"] = $ret;
		}
		return($rep);
	}
}
function get_connection($serveur,$port,$login,$pass)
{
	global $ErrMessage;
	if ( ( $fs = fsockopen($serveur,$port,&$errno,&$errstr,15) ) != false )
	{	
		$ret = fgets($fs);
		if ( substr($ret,0,3) == "+OK" )
		{
			fputs($fs,"USER ".$login."\r\n");
			$ret = fgets($fs);
			if ( substr($ret,0,3) == "+OK" )
			{
				fputs($fs,"PASS ".$pass."\r\n");
				$ret = fgets($fs);
				if ( substr($ret,0,3) == "+OK" )
				{
					return($fs);
				}
				else
					$ErrMessage=$ret;
			}
			else
				$ErrMessage=$ret;
		}
		else
			$ErrMessage=$ret;
	}
	else
		$ErrMessage=$errno . "=" . $errstr;
	return false;
}
function close_connection($fs)
{
	fputs($fs,"QUIT \r\n");
	fclose($fs);
}
function get_emails_tab($liste,$nolink=false)
{
	$res="";
	$liste = fozzy_mime_decode($liste);
	if ( eregi("undisclosed\-recipient",$liste) )
	{
		echo "destinataires cachs";
	}
	else
	{
		preg_match_all("/([^@\s<\"]*@[^\s>,\"]*)/i",$liste,$emails);
		$names = preg_split("/[^@\s<]*@[^\s>,]*/i",$liste);
		$i = count( $emails[1] );
		for ( $j=0; $j<$i; $j++ )
		{
			if ( $j > 0 ) echo ";&nbsp;";
			$nm = stripslashes(trim(ereg_replace("[\r\n\t<>\",]","",$names[$j])));
			$em = trim($emails[1][$j]);
			if ( !$nolink )
			{
				echo "<a href=\"#\" onclick=\"add_contact('".addslashes($nm)."','".addslashes($em)."');return false;\" class=A_Unseen ";
				echo "onmouseover=\"Info_Bulle('Ajouter ".addslashes($em)." aux contacts');return false;\">";
			}
			if ( $nm != "" ) 
				echo $nm;
			else
				echo $em;
			if ( !$nolink )
			{
				echo "</a>";
			}
		}
	}
}
function get_emails_list($liste)
{
	$res="";
	$liste = fozzy_mime_decode($liste);
	if ( eregi("undisclosed\-recipient",$liste) )
	{
		$res="destinataires cachs";
	}
	else
	{
		preg_match_all("/([^@\s<\"]*@[^\s>,\"]*)/i",$liste,$emails);
		$names = preg_split("/[^@\s<]*@[^\s>,]*/i",$liste);
		$i = count( $emails[1] );
		for ( $j=0; $j<$i; $j++ )
		{
			if ( $j > 0 ) $res .= ";&nbsp;";
			$nm = stripslashes(trim(ereg_replace("[\r\n\t<>\",]","",$names[$j])));
			$em = trim($emails[1][$j]);
			if ( $nm != "" ) 
				$res .= $nm;
			else
				$res .= $em;
		}
	}
	return($res);
}
function get_emails_emails($liste)
{
	$res="";
	$liste = fozzy_mime_decode($liste);
	if ( eregi("undisclosed\-recipient",$liste) )
	{
		$res="";
	}
	else
	{
		preg_match_all("/([^@\s<\"]*@[^\s>,\"]*)/i",$liste,$emails);
		$i = count( $emails[1] );
		for ( $j=0; $j<$i; $j++ )
		{
			$tmp = stripslashes(trim(ereg_replace("[\r\n\t<>\",]","",$emails[1][$j])));
			if ( $tmp != "" )
			{
				if ( $j > 0 ) $res .= "; ";
				$res .= $tmp;
			}
		}
	}
	return($res);
}
?>
